<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */

/**
 * Définition d’une classe qui stocke des informations sur une personne.
 * 
 */
class Personne
{ 
	// Définition des attributs.
	//  
	public  $nom; // nom de la personne
	public  $prenom; // prenom de la personne
	public  $langue = "fr_FR"; // langue de la personne
	                         // français par défaut 
	                         
	private $timestamp; // date/heure de création (privé)

	// Définition des méthodes : 

	/**
	* le constructeur
	* @param [type] $prenom [description]
	* @param [type] $nom    [description]
	*/
	public function __construct($sPrenom,$sNom)
	{ 
		// Init le nom et le prenom 
		// avec les valeurs passées en paramètre. 
		$this->prenom = $sPrenom; 
		$this->nom = $sNom; 

		// Init timestamp avec la fonction time(). 
		$this->timestamp = time(); 
	} 


	/**
	* Le destructeur
	* Pour supprimer des ressources...
	*/
	public function __destruct()
	{ 
		// afficher un message. 
		echo "<p><b>Suppression de ".$this->nom." ".$this->prenom."</b></p>"; 
	} 



	/**
	* Conversion de l’objet en chaîne
	* @return string [description]
	*/
	public function __toString()
	{ 
		// Retourne juste le nom et le prenom. 
		return "__toString = ".$this->nom." - ".$this->prenom; 
	} 



	/**
	* Met à jour la langue de l’utilisateur.
	* @param  [type] $sLangue [description]
	* @return [type]         [description]
	*/
	public function langue($sLangue)
	{ 
		$this->langue = $sLangue; 
	} 


	/**
	* met en forme la date/heure de création de la personne.
	*  
	*/
	private function setTimestamp()
	{ 
		setlocale(LC_TIME,$this->langue); 
		return strftime('%c', $this->timestamp); 
	}

	/**
	* Renvoie les informations de la personne
	* @return [type] [description]
	*/
	public function getInfos()
	{ 
		$sDateCreate = $this->setTimestamp(); 
		return $this->prenom." ".$this->nom." - ".$sDateCreate; 
	} 

} 


// instanciation de la classe

// Instanciation d’un objet. 
$oProgrammeur = new Personne("Matthieu", "Developpement"); 

// La variable $oProgrammeur contient maintenant un objet basé sur la  
// classe utilisateur.
// Les méthodes sont accessibles avec l'opérateur ->. 

// Utilisation des méthodes de l'objet Personne.

echo $oProgrammeur->getInfos()."<br/><br/>"; 

$oProgrammeur->langue("en_US");  // modification de la langue 

echo $oProgrammeur->getInfos()."<br/><br/>";  

// Modification et lecture directe d’un attribut public 
$oProgrammeur->nom = strtoupper($oProgrammeur->nom); 
echo $oProgrammeur->nom."<br/><br/>"; 

// Affichage direct de l’objet => utilisation de __toString 
echo $oProgrammeur."<br/><br/>"; 


// création d'un autre objet avec la même classe Personne
$oProgrammeur2 = new Personne("Yannick", "ActionScript"); 
echo $oProgrammeur2->getInfos()."<br/><br/>";

$oProgrammeur2->nom = strtoupper($oProgrammeur2->nom);
echo $oProgrammeur2->getInfos()."<br/>";



?>
